﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Public Class Form1
   Private moShapeFileDegrees As ShapeFileFeatureLayer
   Private moShapeFileMeters As ShapeFileFeatureLayer
   Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
      txt1.Text = "Note that the project is set to use the Unmanaged Geometry Library (when form loads). Place a breakpoint in btnDoSearch_Click. Click the button to " &
                  "search with GetFeaturesWithinDistanceOf. Note that an exception is generated. Now stop the application and change it to use the Manged Geometry " &
                  "Library. Now GetFeaturesWithinDistanceOf produces a result without an error."


      mLoadData()
   End Sub
   Private Sub mLoadData()
      Dim sPath1 As String = "..\..\Data\shp2.shp"
      Dim sPath2 As String = "..\..\Data\OneCounty.shp"
      Dim sSym1 As AreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Black, 1)
      Dim sSym2 As AreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 1)
      Dim oProj4 As ManagedProj4Projection

      BaseShape.GeometryLibrary = GeometryLibrary.Unmanaged

      moShapeFileDegrees = New ShapeFileFeatureLayer(sPath1, ShapeFileReadWriteMode.ReadOnly)
      moShapeFileDegrees.Name = "ShapeFileDegrees"
      moShapeFileDegrees.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = sSym1
      moShapeFileDegrees.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      oProj4 = New ManagedProj4Projection(ManagedProj4Projection.GetEsriParametersString(4326), ManagedProj4Projection.GetEsriParametersString(102003))
      moShapeFileDegrees.FeatureSource.Projection = oProj4



      moShapeFileMeters = New ShapeFileFeatureLayer(sPath2, ShapeFileReadWriteMode.ReadOnly)
      moShapeFileMeters.Name = "ShapeFileMeters"
      moShapeFileMeters.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = sSym2
      moShapeFileMeters.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

      Dim oLayers As New LayerOverlay
      oLayers.Layers.Add(moShapeFileDegrees.Name, moShapeFileDegrees)
      oLayers.Layers.Add(moShapeFileMeters.Name, moShapeFileMeters)

      WinformsMap1.Overlays.Add(oLayers)

      moShapeFileDegrees.Open()
      WinformsMap1.MapUnit = GeographyUnit.Meter

      WinformsMap1.CurrentExtent = moShapeFileDegrees.GetBoundingBox

      WinformsMap1.Refresh()
   End Sub


   Private Sub btnDoSearch_Click(sender As System.Object, e As System.EventArgs) Handles btnDoSearch.Click
      Dim oShape As AreaBaseShape

      oShape = CType(moShapeFileDegrees.QueryTools.GetFeatureById("1", ReturningColumnsType.AllColumns).GetShape, AreaBaseShape)

      Dim oSearchPoint As PointShape = oShape.GetCenterPoint
      Try
         Dim oFeatures = moShapeFileDegrees.QueryTools.GetFeaturesWithinDistanceOf(oSearchPoint, GeographyUnit.Meter, DistanceUnit.Meter, 0.01, ReturningColumnsType.NoColumns)
      Catch ex As Exception
         MessageBox.Show("Exception:" & vbCrLf & ex.Message)
         Debug.WriteLine(ex.Message)
      End Try


   End Sub
End Class
